#include <windows.h>
#include <windowsx.h>
#include "types.h"

#define DEFWIDTH 435
#define DEFHEIGHT 360

const char className[]="MainForm"; //  
HWND main_window; //  

// 
BOOL OnCreate(HWND, LPCREATESTRUCT);
void OnPaint(HWND);

LRESULT CALLBACK WinProc(HWND, UINT, WPARAM, LPARAM); //     


int WINAPI WinMain(HINSTANCE hThisInstance /*   */,
                   HINSTANCE, LPSTR cmdLine, int showStyle /*    */)

{

    //  
    WNDCLASSEX wc; //  
    ZeroMemory(&wc, sizeof(wc));
    wc.hInstance=hThisInstance; // 
    wc.lpszClassName=className; // 
    wc.lpfnWndProc=WinProc; //  
    wc.cbSize = sizeof(WNDCLASSEX);

    wc.style=CS_VREDRAW|CS_VREDRAW; //  
    wc.hIcon=LoadIcon(NULL, IDI_APPLICATION); //  Windows
    wc.hCursor=LoadCursor(NULL, IDC_ARROW); //  Windows
    wc.lpszMenuName = NULL; /* No menu */
    //wc.hbrBackground=(HBRUSH)GetStockObject(LTGRAY_BRUSH); //   -  
    wc.hbrBackground=CreateSolidBrush(RGB(221, 221, 221)); //-

    RegisterClassEx(&wc); //  


    //  
    main_window=CreateWindow( className, "", /*    */
                                   WS_OVERLAPPEDWINDOW, 150, 100, DEFWIDTH+5, DEFHEIGHT+25, /*  ,    */
                                   HWND_DESKTOP, NULL /* No menu */, hThisInstance /* */, NULL /*.*/
                                  );

    ShowWindow(main_window, showStyle); // 


    // 
    MSG msg;
    while(GetMessage(&msg, NULL, 0, 0))
    {
           TranslateMessage(&msg); //Translate virtual-key messages into character messages
           DispatchMessage(&msg);  //Send message to WindowProcedure
    }

    return msg.wParam;
}


////////////////////////////////////////////////////////////////////////////////

/* This function is called by the Windows function DispatchMessage( ) */
LRESULT CALLBACK WinProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch (msg)
    {
           HANDLE_MSG(hwnd, WM_CREATE, OnCreate); //  
           HANDLE_MSG(hwnd, WM_PAINT, OnPaint);
           case WM_DESTROY:
                PostQuitMessage(0); //  
           break;

           default:
                return DefWindowProc(hwnd, msg, wParam, lParam); // 
    }
    return 0;
}

BOOL OnCreate(HWND, LPCREATESTRUCT)
{
    // 
    paint::hSunBrush=CreateSolidBrush(RGB(250, 250, 0));
    paint::hSunPen=CreatePen(PS_DASHDOT, 1, RGB(128, 255, 255));
    paint::hSkyPen=CreatePen(PS_NULL, 0, RGB(128, 255, 255));

    paint::hSkyBrush=CreateSolidBrush(RGB(128, 255, 255));
    paint::hGrassBrush=CreateSolidBrush(RGB(0, 155, 0));

    paint::bgHouse=CreateSolidBrush(RGB(128, 0, 128));
    paint::bgRoof=CreateSolidBrush(RGB(255, 0, 255));
    paint::bgWindow=CreateSolidBrush(RGB(0, 0, 255));
    paint::bgDoor=CreateSolidBrush(RGB(0, 0, 80));
    paint::bgFlue=CreateSolidBrush(RGB(255, 0, 0));

    paint::hBlackPen=CreatePen(PS_SOLID, 1, RGB(0,0,0));
    paint::hYellowPen=CreatePen(PS_SOLID, 1, RGB(250, 250, 0));
    paint::hDarkPen=CreatePen(PS_SOLID, 1, RGB(148,148,148));

    // 
    paint::RoofPoints[0].x=39;  paint::RoofPoints[0].y=146;
    paint::RoofPoints[1].x=76;  paint::RoofPoints[1].y=103;
    paint::RoofPoints[2].x=112; paint::RoofPoints[2].y=146;

    return true; // 
}

void OnPaint(HWND hwnd)
{
    PAINTSTRUCT paintstruct;
    HDC hdc=BeginPaint(hwnd, &paintstruct);

     // 
     SelectBrush(hdc, paint::hSkyBrush);
     SelectPen(hdc, paint::hSkyPen);
     Rectangle(hdc, 0, 0, DEFWIDTH, DEFHEIGHT);

     // 
     SelectBrush(hdc, paint::hGrassBrush);
     SelectPen(hdc, paint::hSkyPen);
     Rectangle(hdc, 0, ((DEFHEIGHT>>1) - (DEFHEIGHT>>4)), DEFWIDTH, DEFHEIGHT);

     const RECT& area=paintstruct.rcPaint; // 

     if((area.left<=391/*right*/ && area.right>=311/*left*/) && (area.top<=97 && area.bottom>=17)){
         // 
         SelectBrush(hdc, paint::hSunBrush);
         SelectPen(hdc, paint::hSunPen);
         Ellipse(hdc, 311, 17, 391, 97);
     }

     // 
     if((area.left<=112/*right*/ && area.right>=29/*left*/) && (area.top<=195 && area.bottom>=103)){
         // 
         SelectPen(hdc, paint::hBlackPen);
         SelectBrush(hdc, paint::bgHouse);
         Rectangle(hdc, 44, 145, 107, 195);
         //
         SelectPen(hdc, paint::hYellowPen);
         SelectBrush(hdc, paint::bgWindow);
         Rectangle(hdc, 53, 160, 75, 180);
         //
         SelectPen(hdc, paint::hDarkPen);
         SelectBrush(hdc, paint::bgDoor);
         Rectangle(hdc, 86, 162, 102, 194);
         //
         SelectPen(hdc, paint::hDarkPen);
         SelectBrush(hdc, paint::bgFlue);
         Rectangle(hdc, 91, 110, 98, 129);
         //
         SelectPen(hdc, paint::hBlackPen);
         SelectBrush(hdc, paint::bgRoof);
         Polygon(hdc, paint::RoofPoints, 3);
     }
    EndPaint(hwnd, &paintstruct);
}
